/**
 * html-webpack-plugin插件处理html之前，写入需要引入的js文件
 * 调用方法如下
 * new ChoiceAddScipt({
        paths: ["./demo.js"]
    }),
 * */

function ChoiceAddScipt(options) {
  this.options = options;
}

ChoiceAddScipt.prototype.apply = function (compiler) {
  const paths = this.options.paths;
  compiler.plugin('compilation', (compilation) => {
    compilation.plugin('html-webpack-plugin-before-html-processing', (htmlPluginData, callback) => {
      paths.forEach((element) => {
        htmlPluginData.assets.js.unshift(element);
      });
      callback(null, htmlPluginData);
    });
  });
};

module.exports = ChoiceAddScipt;
